unit main;

interface

uses
    Windows, Messages, SysUtils, Classes, Forms, Controls, Menus, Graphics,
    ExtCtrls, StdCtrls, Buttons, ActnList, StdActns, ImgList, ComCtrls,
  ToolWin;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    ActionList: TActionList;
    WindowClose1: TWindowClose;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowTileVertical1: TWindowTileVertical;
    WindowMinimizeAll1: TWindowMinimizeAll;
    WindowArrange1: TWindowArrange;
    MenuWindow: TMenuItem;
    MenuArrangeIcon: TMenuItem;
    MenuCascade: TMenuItem;
    MenuClose: TMenuItem;
    MenuMinimizeAll: TMenuItem;
    MenuTileHorizontal: TMenuItem;
    MenuTileVertical: TMenuItem;
    Panel1: TPanel;
    ToolBar: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList: TImageList;
    ImgBack: TImage;
    ToolButton4: TToolButton;
    MenuConfig: TMenuItem;
    ConfigPutSetFore: TAction;
    MenuPutSetFore: TMenuItem;
    ToolButton5: TToolButton;
    Panel2: TPanel;
    Splitter1: TSplitter;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Splitter1Paint(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListBox1Click(Sender: TObject);
  private
    FClientWndProc: Pointer;
    FOrgWndProc: Pointer;
    AllocHandle:HWND;
    procedure ClientWndProc(var Msg: TMessage);
    procedure CreateMDIChild(const Name: string);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
  private
  private
    FStrBuf: TStringList;
  protected
    procedure CreateParams(var Params: TCreateParams);override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure CallOnReleaseMDIChild(Sender: TForm);
    procedure CallOnActivateMDIChild(Sender: TForm);
  end;

var
    MainForm: TMainForm;

//-----------------------------------------------------------------------------
//  dNp̔閧̒l
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
const
    UNIQUE_NAM: string = '{FC63976B-527F-4A43-B7CC-7D57B0E940A1}';
    UNIQUE_NUM: Cardinal = $00001111;

implementation

{$R *.dfm}

uses
    child, ShellApi;

//-----------------------------------------------------------------------------
//  j[NȃNXw肵ăbZ[WMpEBhE֐
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
function AllocMsgWnd(Method: TWndMethod; ClassName:string): HWND;
var
    DummyClass: TWndClass;
begin
    FillChar(DummyClass, SizeOf(TWndClass), #0);
    DummyClass.hInstance := hInstance;
    DummyClass.lpfnWndProc := @DefWindowProc;
    DummyClass.lpszClassName := PChar(ClassName);
    Windows.RegisterClass(DummyClass);
    Result := CreateWindowEx(WS_EX_TOOLWINDOW, DummyClass.lpszClassName,
                             '', WS_POPUP, 0, 0, 0, 0, 0, 0, hInstance, nil);
    if Assigned(Method) then
        SetWindowLong(Result,GWL_WNDPROC,LongInt(Classes.MakeObjectInstance(Method)));
end;

//-----------------------------------------------------------------------------
//  RXgN^
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    // \bhƂĒ`EBhEvV[WGg|Cg쐬
    FClientWndProc := Classes.MakeObjectInstance(ClientWndProc);
    // 쐬łAMDI NCAg̃EBhEvV[WƂ
    // o^ÃGgۑ
    if FClientWndProc <> nil then
    begin
        FOrgWndProc := Pointer(SetWindowLong(ClientHandle, GWL_WNDPROC,
                                            Longint(FClientWndProc)));
    end;
    //  bZ[WMp
    if AllocHandle = 0 then AllocHandle := AllocMsgWnd(ClientWndProc, UNIQUE_NAM);
end;
//-----------------------------------------------------------------------------
//  fXgN^
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
destructor TMainForm.Destroy;
begin
    // fXgN^ŃEBhEvV[Wɖ߂
    if FOrgWndProc <> nil then
    begin
        SetWindowLong(ClientHandle, GWL_WNDPROC, Longint(FOrgWndProc));
    end;
    //  bZ[WMp
    Classes.DeallocateHwnd(AllocHandle);
    AllocHandle := 0;
    inherited;
end;

//-----------------------------------------------------------------------------
//  ւp̃EBhEvV[W
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=268
procedure TMainForm.ClientWndProc(var Msg: TMessage);
var
    R: TRect;
    i: integer;
    Buf: PChar;
    CopyData: PCopyDataStruct;
begin
    case Msg.Msg of

    //  wi`掞
    WM_ERASEBKGND:
        begin
            //  MDINCAg̈擾
            Windows.GetClientRect(ClientHandle, R);
            //  w̃rbg}bvœhԂ
            Brush.Bitmap := ImgBack.Picture.Bitmap;
            FillRect(TWMEraseBkgnd(Msg).DC, R, Brush.Handle);
            Brush.Bitmap := nil;
        end;

    //  ʂ̃CX^X瑗Ăe
    WM_COPYDATA:
        begin
            CopyData := PCopyDataStruct(Msg.LParam);
            if CopyData^.dwData = UNIQUE_NUM then
            begin
                Buf := StrALloc(CopyData^.cbData);
                try
                    StrCopy(Buf, CopyData^.lpData);
                    FStrBuf.CommaText := Buf;
                finally
                    StrDispose(Buf);
                end;
                for i := 0 to FStrBuf.Count - 1 do
                begin
                    CreateMDIChild(FStrBuf.Strings[i]);
                end;
            end;
        end;

    //  ̑̑SĂ̏ꍇ
    else
        Msg.Result := CallWindowProc(FOrgWndProc, ClientHandle,
                                        Msg.Msg, Msg.WParam, Msg.LParam);
    end;
end;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    FileName: Array[0..MAX_PATH] of Char;
    i, Count: integer;
begin
    //  hbvꂽt@C̐擾
    Count := DragQueryFile(Msg.Drop, DWORD(-1), FileName, SizeOf(FileName));
    for i := 0 to Count - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
        //  ꂪt@CȂ
        if (FileExists(FileName)) then
        begin
            //  qʋN
            CreateMDIChild(FileName);
        end;
        //  őOʂɎĂ
        if (MenuPutSetFore.Checked) then SetForegroundWindow(Application.Handle);
    end;
    //  hbv
    DragFinish(Msg.Drop);
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  GpXg쐬
    FStrBuf := TStringList.Create;
    //  EBhEIXg\[g
    ListBox1.Sorted := true;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  GpXgj
    FStrBuf.Free;
end;

//-----------------------------------------------------------------------------
//  tH[\
procedure TMainForm.FormShow(Sender: TObject);
var
    i: integer;
begin
    //  NɃACRɃhbvꂽt@C
    for i := 1 to ParamCount do
    begin
        CreateMDIChild(ParamStr(i));
    end;
end;

//-----------------------------------------------------------------------------
//  qʍ쐬
procedure TMainForm.CreateMDIChild(const Name: string);
var
    Child: TMDIChild;
    index: integer;
begin
    //  ɓo^ĂȂ
    index := ListBox1.Items.IndexOf(Name);

    if (index <> -1) then
    begin
        ListBox1.ItemIndex := index;
        ListBox1Click(ListBox1);
    end
    else
    begin
        Child := TMDIChild.Create(Application);
        Child.Caption := Name;
        ListBox1.Items.AddObject(Name, Child);
        CallOnActivateMDIChild(Child);
    end;
end;

//-----------------------------------------------------------------------------
//  qʍ폜
procedure TMainForm.CallOnReleaseMDIChild(Sender: TForm);
var
    Child: TMDIChild;
    index: integer;
begin
    Child := TMDIChild(Sender);
    index := ListBox1.Items.IndexOfObject(Child);
    if (index <> -1) then ListBox1.Items.Delete(index);
end;

//-----------------------------------------------------------------------------
//  qʃANeBu
procedure TMainForm.CallOnActivateMDIChild(Sender: TForm);
var
    Child: TMDIChild;
begin
    Child := TMDIChild(Sender);
    ListBox1.ItemIndex := ListBox1.Items.IndexOfObject(Child);
end;

//-----------------------------------------------------------------------------
//  EBhEIXgI
procedure TMainForm.ListBox1Click(Sender: TObject);
var
    LBox: TListBox;
    Child: TMDIChild;
begin
    LBox := TListBox(Sender);
    if (LBox.ItemIndex <> -1) then
    begin
        Child := TMDIChild(LBox.Items.Objects[LBox.ItemIndex]);
        if (Child <> nil) then
        begin
            Child.BringToFront;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  Ճb^[`掞
procedure TMainForm.Splitter1Paint(Sender: TObject);
var
    Splitter: TSplitter;
begin
    Splitter := TSplitter(Sender);
    Splitter.Canvas.Brush.Bitmap := ImgBack.Picture.Bitmap;
    Splitter.Canvas.FillRect(Splitter.ClientRect);
    Splitter.Canvas.Brush.Bitmap := nil;
end;

//-----------------------------------------------------------------------------
//  EBhEIXg`掞
//  http://kazina.jugem.jp/?eid=55
procedure TMainForm.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    LBox: TListBox;
    FileName, DispName: string;
    OffsetX, OffsetY: integer;
begin
    LBox := TListBox(Control);

    //  `e
    FileName := LBox.Items.Strings[Index];
    DispName := ExtractFileName(FileName);

    //  `ʒu
    OffsetX := Rect.Left + 5;
    OffsetY := Rect.Top + (Rect.Bottom - Rect.Top - LBox.Canvas.TextHeight('Wg')) div 2;

    //  wihԂ
    if (odFocused in State) then
    begin
        LBox.Canvas.Brush.Color := $00D2BDB6;
        LBox.Canvas.FillRect(Rect);
        LBox.Canvas.Brush.Color := $006A240A;
        LBox.Canvas.FrameRect(Rect);
        LBox.Canvas.DrawFocusRect(Rect);
    end
    else if (odSelected in State) then
    begin
        LBox.Canvas.Brush.Color := $00D2BDB6;
        LBox.Canvas.FillRect(Rect);
        LBox.Canvas.DrawFocusRect(Rect);
    end
    else
    begin
        LBox.Canvas.Brush.Color := $00F7F8F9;
        LBox.Canvas.FillRect(Rect);
    end;

    //  LvV`
    LBox.Canvas.Font.Color := clBlack;
    LBox.Canvas.Brush.Style := bsClear;
    LBox.Canvas.TextOut(OffsetX, OffsetY, DispName);
    LBox.Canvas.Brush.Style := bsSolid;
end;

end.
